// Ejercicio 38: Mantenimiento de libros (Solucin 1)

// Visualizacin de las opciones del men por pantalla
SubProceso Menu_por_Pantalla()
	Escribir ""
	Escribir ">>> MEN MANTENIMIENTO DE LIBROS <<<"
	Escribir ""
	Escribir "1. Introducir uno o varios libros."
	Escribir "2. Mostrar datos de un libro."
	Escribir "3. Modificar datos de un libro."
	Escribir "4. Borrar un libro."
	Escribir "5. Buscar libros por autor."
	Escribir "6. Listar todos los libros."
	Escribir "7. Salir."
	Escribir ""
FinSubProceso

// Opcin 1. Introducir uno o varios libros
SubProceso Introducir_Libros(libros Por Referencia, contador Por Referencia)
	
	Definir guardar, seguir Como Caracter
	Definir titulo, autor, anio Como Cadena
	
	Si contador <> 5 Entonces
		
		Repetir
			
			contador <- contador + 1
			
			Escribir ""
			Escribir "Introduzca datos del libro ", contador ":"
			Escribir ""
			Escribir Sin Saltar "TTULO..: "
			Leer titulo
			Escribir Sin Saltar "AUTOR...: "
			Leer autor
			Escribir Sin Saltar "AO.....: "
			Leer anio
			Escribir ""
			
			Repetir
				Escribir Sin Saltar "Guardar los datos introducidos (s/n)?: "
				Leer guardar
			Hasta Que guardar = 's' | guardar = 'S' | guardar = 'n' | guardar = 'N'
			
			Si guardar = 's' | guardar = 'S' Entonces
				libros[contador,1] <- titulo
				libros[contador,2] <- autor
				libros[contador,3] <- anio
				
				Escribir ""
				Escribir "DATOS GUARDADOS."
			SiNo
				Escribir ""
				Escribir "DATOS NO GUARDADOS."
				
				contador <- contador - 1
			FinSi
			
			Si contador <> 5 Entonces
				Escribir ""
				Repetir
					Escribir Sin Saltar "Desea introducir otro libro (s/n)?: "
					Leer seguir
				Hasta Que seguir = 's' | seguir = 'S' | seguir = 'n' | seguir = 'N'
			SiNo
				Escribir ""
				Escribir "NO SE PUEDEN GUARDAR MS LIBROS."
			FinSi
			
		Hasta Que seguir = 'n' | seguir = 'N' | contador = 5
		
	SiNo
		Escribir ""
		Escribir "ERROR: NO SE PUEDEN GUARDAR MS LIBROS."
	FinSi
	
FinSubProceso

// Opcin 2. Mostrar datos de un libro
SubProceso Mostrar_Datos(libros Por Referencia, contador Por Valor)
	
	Definir i Como Entero
	
	Escribir ""
	Si contador <> 0 Entonces
		
		Escribir Sin Saltar "Introduzca nmero de libro a mostrar (1-", contador, "): "
		Leer i
		
		Si i < 1 | i > contador Entonces
			Escribir ""
			Escribir "ERROR: NO EXISTE EL LIBRO ", i, "."
		SiNo
			Escribir ""
			Escribir "LOS DATOS DEL LIBRO ", i, " SON: "
			Escribir ""
			Escribir "TTULO..: ", libros[i,1]
			Escribir "AUTOR...: ", libros[i,2]
			Escribir "AO.....: ", libros[i,3]
		FinSi
		
	SiNo
		Escribir "ERROR: NO HAY NINGN LIBRO ALMACENADO."
	FinSi
	
FinSubProceso

// Opcin 3. Modificar datos de un libro
SubProceso Modificar_Datos(libros Por Referencia, contador Por Valor)
	
	Definir guardar, seguir Como Caracter
	Definir i Como Entero
	Definir titulo, autor, anio Como Cadena
	
	Escribir ""
	Si contador <> 0 Entonces
		
		Escribir Sin Saltar "Introduzca nmero de libro a modificar (1-", contador, "): "
		Leer i
		
		Si i < 1 | i > contador Entonces
			Escribir ""
			Escribir "ERROR: NO EXISTE EL LIBRO ", i, "."
		SiNo
			Escribir ""
			Escribir "LOS DATOS DEL LIBRO ", i, " SON: "
			Escribir ""
			Escribir "TTULO..: ", libros[i,1]
			Escribir "AUTOR...: ", libros[i,2]
			Escribir "AO.....: ", libros[i,3]
			Escribir ""
			
			Repetir
				Escribir Sin Saltar "Desea modificar los datos de este libro (s/n)?: "
				Leer seguir
			Hasta Que seguir = 's' | seguir = 'S' | seguir = 'n' | seguir = 'N'
			
			Si seguir = 's' | seguir = 'S' Entonces
				
				Escribir ""
				Escribir "Introduzca los nuevos datos del libro ", i ":"
				Escribir ""
				Escribir Sin Saltar "TTULO..: "
				Leer titulo
				Escribir Sin Saltar "AUTOR...: "
				Leer autor
				Escribir Sin Saltar "AO.....: "
				Leer anio
				Escribir ""
				
				Repetir
					Escribir Sin Saltar "Guardar los nuevos datos introducidos (s/n)?: "
					Leer guardar
				Hasta Que guardar = 's' | guardar = 'S' | guardar = 'n' | guardar = 'N'
				
				Si guardar = 's' | guardar = 'S' Entonces
					libros[i,1] <- titulo
					libros[i,2] <- autor
					libros[i,3] <- anio
					
					Escribir ""
					Escribir "LOS DATOS DEL LIBRO ", i, " SE HAN MODIFICADO."
				SiNo
					Escribir ""
					Escribir "LOS DATOS DEL LIBRO ", i, " NO SE HAN MODIFICADO."
				FinSi
				
			SiNo
				Escribir ""
				Escribir "DATOS NO MODIFICADOS."
			FinSi
			
		FinSi
		
	SiNo
		Escribir "ERROR: NO HAY NINGN LIBRO ALMACENADO."
	FinSi
	
FinSubProceso

// Opcin 4. Borrar un libro
SubProceso Borrar_Libro(libros Por Referencia, contador Por Referencia)
	
	Definir seguir Como Caracter
	Definir i Como Entero
	
	Escribir ""
	Si contador <> 0 Entonces
		
		Escribir Sin Saltar "Introduzca nmero de libro a borrar (1-", contador, "): "
		Leer i
		
		Si i < 1 | i > contador Entonces
			Escribir ""
			Escribir "ERROR: NO EXISTE EL LIBRO ", i, "."
		SiNo
			Escribir ""
			Escribir "LOS DATOS DEL LIBRO ", i, " SON: "
			Escribir ""
			Escribir "TTULO..: ", libros[i,1]
			Escribir "AUTOR...: ", libros[i,2]
			Escribir "AO.....: ", libros[i,3]
			Escribir ""
			
			Repetir
				Escribir Sin Saltar "Desea borrar este libro (s/n)?: "
				Leer seguir
			Hasta Que seguir = 's' | seguir = 'S' | seguir = 'n' | seguir = 'N'
			
			Si seguir = 's' | seguir = 'S' Entonces
				
				Mientras i < contador Hacer
					libros[i,1] <- libros[i+1,1]
					libros[i,2] <- libros[i+1,2]
					libros[i,3] <- libros[i+1,3]
					i <- i + 1
				FinMientras
				
				contador <- contador - 1
				
				Escribir ""
				Escribir "LIBRO BORRADO."
				
			SiNo
				Escribir ""
				Escribir "LIBRO NO BORRADO."
			FinSi
			
		FinSi
		
	SiNo
		Escribir "ERROR: NO HAY NINGN LIBRO ALMACENADO."
	FinSi
	
FinSubProceso

// Opcin 5. Buscar libros por autor
SubProceso Buscar_Libros(libros Por Referencia, contador Por Valor)
	
	Definir i, j Como Entero
	Definir autor Como Cadena
	
	Escribir ""
	Si contador <> 0 Entonces
		
		Escribir Sin Saltar "Introduzca autor: "
		Leer autor
		
		Escribir ""
		Escribir "LIBROS ENCONTRADOS:"
		Escribir ""
		
		j <- 0
		Para i <- 1 Hasta contador Hacer
			Si libros[i,2] = autor Entonces
				Escribir "[Libro ", i, "]: ", libros[i,1], ", ", libros[i,2], ", ", libros[i,3]
				j <- j + 1
			FinSi
		FinPara
		
		Si j <> 0 Entonces
			Escribir ""
			Escribir "Se ha(n) encontrado ", j, " libro(s) escrito(s) por ", autor, "."
		SiNo
			Escribir "No se ha encontrado ningn libro escrito por ", autor, "."
		FinSi
		
	SiNo
		Escribir "ERROR: NO HAY NINGN LIBRO ALMACENADO."
	FinSi
	
FinSubProceso

// Opcin 6. Listar todos los libros
SubProceso Listar_Libros(libros Por Referencia, contador Por Valor)
	
	Definir i Como Entero
	
	Escribir ""
	Si contador <> 0 Entonces
		
		Escribir "LISTADO DE LIBROS:"
		Escribir ""
		
		Para i <- 1 Hasta contador Hacer
			Escribir "[Libro ", i, "]: ", libros[i,1], ", ", libros[i,2], ", ", libros[i,3]
		FinPara
		
	SiNo
		Escribir "ERROR: NO HAY NINGN LIBRO ALMACENADO."
	FinSi

FinSubProceso

Algoritmo Mantenimiento_de_Libros
	
	Dimension libros[5,3]
	
	Definir opci Como Caracter
	Definir contador Como Entero
	Definir libros Como Cadena
	
	contador <- 0
	
	Repetir
		
		Menu_por_Pantalla()
		
		// Filtramos la opcin elegida por el usuario
		
		Repetir
			Escribir Sin saltar "Introduzca opcin (1-7): "
			Leer opci
		Hasta Que opci >= '1' & opci <= '7'
		
		// La opcin solo puede ser '1', '2', '3', '4', '5', '6' o '7'
		
		Segun opci Hacer
			
			'1': Introducir_Libros(libros, contador)
				
			'2': Mostrar_Datos(libros, contador)
				
			'3': Modificar_Datos(libros, contador)
				
			'4': Borrar_Libro(libros, contador)
				
			'5': Buscar_Libros(libros, contador)
				
			'6': Listar_Libros(libros, contador)
				
		FinSegun
		
	Hasta Que opci = '7'
	
FinAlgoritmo