// Ejercicio 38: Mantenimiento de libros (Solucin 2)

// Gestin de respuestas a diferentes preguntas
Funcion respuesta <- Preguntar(pregunta Por Valor)
	
	Definir respuesta Como Logico
	Definir letra Como Caracter
	
	Repetir
		Escribir Sin Saltar pregunta
		Leer letra
	Hasta Que letra = 's' | letra = 'S' | letra = 'n' | letra = 'N'
	
	Si letra = 's' | letra = 'S' Entonces
		respuesta <- Verdadero
	SiNo
		respuesta <- Falso
	FinSi
	
FinFuncion

// Gestin de mensajes por pantalla
SubProceso Mostrar_Mensaje(codigo Por Valor, num Por Valor, cad Por Valor)
	
	Escribir ""
	Segun codigo Hacer
		1: Escribir "ERROR: NO HAY NINGN LIBRO ALMACENADO."
		2: Escribir "DATOS GUARDADOS."
		3: Escribir "DATOS NO GUARDADOS."
		4: Escribir "NO SE PUEDEN GUARDAR MS LIBROS."
		5: Escribir "ERROR: NO SE PUEDEN GUARDAR MS LIBROS."
		6: Escribir "ERROR: NO EXISTE EL LIBRO ", num, "."
		7: Escribir "LOS DATOS DEL LIBRO ", num, " SON: "
		8: Escribir "DATOS NO MODIFICADOS."
		9: Escribir "LOS DATOS DEL LIBRO ", num, " SE HAN MODIFICADO."
		10: Escribir "LOS DATOS DEL LIBRO ", num, " NO SE HAN MODIFICADO."
		11: Escribir "LIBRO BORRADO."
		12: Escribir "LIBRO NO BORRADO."
		13: Escribir "LIBROS ENCONTRADOS:"
			Escribir ""
		14: Escribir "Se ha(n) encontrado ", num, " libro(s) escrito(s) por ", cad, "."
		15: Escribir "No se ha encontrado ningn libro escrito por ", cad, "."
		16: Escribir "LISTADO DE LIBROS:"
			Escribir ""
	FinSegun
	
FinSubProceso

// Visualizacin de las opciones del men por pantalla
SubProceso Menu_por_Pantalla()
	Escribir ""
	Escribir ">>> MEN MANTENIMIENTO DE LIBROS <<<"
	Escribir ""
	Escribir "1. Introducir uno o varios libros."
	Escribir "2. Mostrar datos de un libro."
	Escribir "3. Modificar datos de un libro."
	Escribir "4. Borrar un libro."
	Escribir "5. Buscar libros por autor."
	Escribir "6. Listar todos los libros."
	Escribir "7. Salir."
	Escribir ""
FinSubProceso

// Opcin 1. Introducir uno o varios libros
SubProceso Introducir_Libros(libros Por Referencia, contador Por Referencia)
	
	Definir seguir Como Caracter
	Definir titulo, autor, anio Como Cadena
	
	Si contador <> 5 Entonces
		
		Repetir
			
			contador <- contador + 1
			
			Escribir ""
			Escribir "Introduzca datos del libro ", contador ":"
			Escribir ""
			Escribir Sin Saltar "TTULO..: "
			Leer titulo
			Escribir Sin Saltar "AUTOR...: "
			Leer autor
			Escribir Sin Saltar "AO.....: "
			Leer anio
			Escribir ""
			
			Si Preguntar("Guardar los datos introducidos (s/n)?: ") Entonces
				libros[contador,1] <- titulo
				libros[contador,2] <- autor
				libros[contador,3] <- anio
				
				Mostrar_Mensaje(2,0,"")
			SiNo
				Mostrar_Mensaje(3,0,"")
				
				contador <- contador - 1
			FinSi
			
			Si contador <> 5 Entonces
				Escribir ""
				Repetir
					Escribir Sin Saltar "Desea introducir otro libro (s/n)?: "
					Leer seguir
				Hasta Que seguir = 's' | seguir = 'S' | seguir = 'n' | seguir = 'N'
			SiNo
				Mostrar_Mensaje(4,0,"")
			FinSi
			
		Hasta Que seguir = 'n' | seguir = 'N' | contador = 5
		
	SiNo
		Mostrar_Mensaje(5,0,"")
	FinSi
	
FinSubProceso

// Opcin 2. Mostrar datos de un libro
SubProceso Mostrar_Datos(libros Por Referencia, contador Por Valor)
	
	Definir i Como Entero
	
	Si contador <> 0 Entonces
		
		Escribir ""
		Escribir Sin Saltar "Introduzca nmero de libro a mostrar (1-", contador, "): "
		Leer i
		
		Si i < 1 | i > contador Entonces
			Mostrar_Mensaje(6,i,"")
		SiNo
			Mostrar_Mensaje(7,i,"")
			Escribir ""
			Escribir "TTULO..: ", libros[i,1]
			Escribir "AUTOR...: ", libros[i,2]
			Escribir "AO.....: ", libros[i,3]
		FinSi
		
	SiNo
		Mostrar_Mensaje(1,0,"")
	FinSi
	
FinSubProceso

// Opcin 3. Modificar datos de un libro
SubProceso Modificar_Datos(libros Por Referencia, contador Por Valor)
	
	Definir i Como Entero
	Definir titulo, autor, anio Como Cadena
	
	Si contador <> 0 Entonces
		
		Escribir ""
		Escribir Sin Saltar "Introduzca nmero de libro a modificar (1-", contador, "): "
		Leer i
		
		Si i < 1 | i > contador Entonces
			Mostrar_Mensaje(6,i,"")
		SiNo
			Mostrar_Mensaje(7,i,"")
			Escribir ""
			Escribir "TTULO..: ", libros[i,1]
			Escribir "AUTOR...: ", libros[i,2]
			Escribir "AO.....: ", libros[i,3]
			Escribir ""
			
			Si Preguntar("Desea modificar los datos de este libro (s/n)?: ") Entonces
				
				Escribir ""
				Escribir "Introduzca los nuevos datos del libro ", i ":"
				Escribir ""
				Escribir Sin Saltar "TTULO..: "
				Leer titulo
				Escribir Sin Saltar "AUTOR...: "
				Leer autor
				Escribir Sin Saltar "AO.....: "
				Leer anio
				Escribir ""
				
				Si Preguntar("Guardar los nuevos datos introducidos (s/n)?: ") Entonces
					libros[i,1] <- titulo
					libros[i,2] <- autor
					libros[i,3] <- anio
					
					Mostrar_Mensaje(9,i,"")
				SiNo
					Mostrar_Mensaje(10,i,"")
				FinSi
				
			SiNo
				Mostrar_Mensaje(8,0,"")
			FinSi
			
		FinSi
		
	SiNo
		Mostrar_Mensaje(1,0,"")
	FinSi
	
FinSubProceso

// Opcin 4. Borrar un libro
SubProceso Borrar_Libro(libros Por Referencia, contador Por Referencia)
	
	Definir i Como Entero
	
	Si contador <> 0 Entonces
		
		Escribir ""
		Escribir Sin Saltar "Introduzca nmero de libro a borrar (1-", contador, "): "
		Leer i
		
		Si i < 1 | i > contador Entonces
			Mostrar_Mensaje(6,i,"")
		SiNo
			Mostrar_Mensaje(7,i,"")
			Escribir ""
			Escribir "TTULO..: ", libros[i,1]
			Escribir "AUTOR...: ", libros[i,2]
			Escribir "AO.....: ", libros[i,3]
			Escribir ""
			
			Si Preguntar("Desea borrar este libro (s/n)?: ") Entonces
				
				Mientras i < contador Hacer
					libros[i,1] <- libros[i+1,1]
					libros[i,2] <- libros[i+1,2]
					libros[i,3] <- libros[i+1,3]
					i <- i + 1
				FinMientras
				
				contador <- contador - 1
				
				Mostrar_Mensaje(11,0,"")
				
			SiNo
				Mostrar_Mensaje(12,0,"")
			FinSi
			
		FinSi
		
	SiNo
		Mostrar_Mensaje(1,0,"")
	FinSi
	
FinSubProceso

// Opcin 5. Buscar libros por autor
SubProceso Buscar_Libros(libros Por Referencia, contador Por Valor)
	
	Definir i, j Como Entero
	Definir autor Como Cadena
	
	Si contador <> 0 Entonces
		
		Escribir ""
		Escribir Sin Saltar "Introduzca autor: "
		Leer autor
		
		Mostrar_Mensaje(13,0,"")
		
		j <- 0
		Para i <- 1 Hasta contador Hacer
			Si libros[i,2] = autor Entonces
				Escribir "[Libro ", i, "]: ", libros[i,1], ", ", libros[i,2], ", ", libros[i,3]
				j <- j + 1
			FinSi
		FinPara
		
		Si j <> 0 Entonces
			Mostrar_Mensaje(14,j,autor)
		SiNo
			Mostrar_Mensaje(15,0,autor)
		FinSi
		
	SiNo
		Mostrar_Mensaje(1,0,"")
	FinSi
	
FinSubProceso

// Opcin 6. Listar todos los libros
SubProceso Listar_Libros(libros Por Referencia, contador Por Valor)
	
	Definir i Como Entero
	
	Si contador <> 0 Entonces
		
		Mostrar_Mensaje(16,0,"")
		
		Para i <- 1 Hasta contador Hacer
			Escribir "[Libro ", i, "]: ", libros[i,1], ", ", libros[i,2], ", ", libros[i,3]
		FinPara
		
	SiNo
		Mostrar_Mensaje(1,0,"")
	FinSi

FinSubProceso

Algoritmo Mantenimiento_de_Libros
	
	Dimension libros[5,3]
	
	Definir opci Como Caracter
	Definir contador Como Entero
	Definir libros Como Cadena
	
	contador <- 0
	
	Repetir
		
		Menu_por_Pantalla()
		
		// Filtramos la opcin elegida por el usuario
		
		Repetir
			Escribir Sin saltar "Introduzca opcin (1-7): "
			Leer opci
		Hasta Que opci >= '1' & opci <= '7'
		
		// La opcin solo puede ser '1', '2', '3', '4', '5', '6' o '7'
		
		Segun opci Hacer
			
			'1': Introducir_Libros(libros, contador)
				
			'2': Mostrar_Datos(libros, contador)
				
			'3': Modificar_Datos(libros, contador)
				
			'4': Borrar_Libro(libros, contador)
				
			'5': Buscar_Libros(libros, contador)
				
			'6': Listar_Libros(libros, contador)
				
		FinSegun
		
	Hasta Que opci = '7'
	
FinAlgoritmo